SET SQL DIALECT 1;

CREATE DATABASE 'test2020v4.ib' USER 'SYSDBA' password 'masterkey' PAGE_SIZE 4096 WITH ADMIN OPTION
 DEFAULT CHARACTER SET UTF8;
COMMIT WORK;

CONNECT 'test2020v4.ib' USER 'SYSDBA' PASSWORD 'masterkey';
CREATE USER SYSDSO SET PASSWORD 'masterkey';
COMMIT WORK;

CONNECT 'test2020v4.ib' USER 'SYSDSO' PASSWORD 'masterkey'; 
ALTER DATABASE SET SYSTEM ENCRYPTION PASSWORD 'masterkey';
COMMIT WORK;

CONNECT 'test2020v4.ib' USER 'SYSDBA' PASSWORD 'masterkey';

CREATE EXCEPTION CUSTOMER_CHECK 'Overdue balance -- can not ship.';
CREATE EXCEPTION CUSTOMER_ON_HOLD 'This customer is on hold.';
CREATE EXCEPTION ORDER_ALREADY_SHIPPED 'Order status is "shipped."';
CREATE EXCEPTION REASSIGN_SALES 'Reassign the sales records before deleting this employee.';
CREATE EXCEPTION UNKNOWN_EMP_ID 'Invalid employee number or project id.';

CREATE DOMAIN ADDRESSLINE AS VARCHAR(30);
CREATE DOMAIN COUNTRYNAME AS VARCHAR(15);
CREATE DOMAIN DEPTNO AS CHAR(3)
           CHECK (VALUE = '000' OR (VALUE > '0' AND VALUE <= '999') OR VALUE IS NULL);
CREATE DOMAIN FIRSTNAME AS VARCHAR(15);
CREATE DOMAIN JOBGRADE AS SMALLINT
            CHECK (VALUE BETWEEN 0 AND 6);
CREATE DOMAIN PHONENUMBER AS VARCHAR(20);
CREATE DOMAIN PRODTYPE AS VARCHAR(12)
            DEFAULT 'software'
            NOT NULL
            CHECK (VALUE IN ('software', 'hardware', 'other', 'N/A'));
CREATE DOMAIN SALARY AS NUMERIC(10, 2)
            DEFAULT 0
            CHECK (VALUE > 0);
CREATE DOMAIN BUDGET AS DECIMAL(12, 2)
            DEFAULT 50000
            CHECK (VALUE > 10000 AND VALUE <= 2000000);
CREATE DOMAIN CUSTNO AS INTEGER
            CHECK (VALUE > 1000);
CREATE DOMAIN EMPNO AS SMALLINT;
CREATE DOMAIN JOBCODE AS VARCHAR(5)
            CHECK (VALUE > '99999');
CREATE DOMAIN LASTNAME AS VARCHAR(20);
CREATE DOMAIN PONUMBER AS CHAR(8)
            CHECK (VALUE STARTING WITH 'V');
CREATE DOMAIN PROJNO AS CHAR(5)
            CHECK (VALUE = UPPER (VALUE));

COMMIT WORK;

/* Table: AR, Owner: SYSDBA */
CREATE TABLE AR 
(
    C1 INTEGER,
    C2 INTEGER[1:4, 0:3, 1:2] ,
    C3 VARCHAR(15)[0:5, 1:2] ,
    C4 CHAR(5)[1:5] ,
    C5 TIMESTAMP[1:2] ,
    C6 TIMESTAMP[1:2] ,
    C7 DECIMAL(10, 2)[1:2] ,
    C8 DECIMAL(10, 2)[1:2] ,
    C9 SMALLINT[1:2] ,
    C10 INTEGER[1:2] ,
    C11 FLOAT[1:2] ,
    C12 DOUBLE PRECISION[1:2] ,
    C13 DECIMAL(10, 1)[1:2] ,
    C14 DECIMAL(10, 5)[1:2] ,
    C15 DECIMAL(18, 5)[1:2]
);

INSERT INTO AR (C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15) values (1,'','','','','','','','','','','',NULL,NULL,NULL);
INSERT INTO AR (C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15) values (2, '',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO AR (C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15) values (3, NULL,'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO AR (C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15) values (4, NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO AR (C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15) values (5, NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO AR (C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15) values (6, NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO AR (C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15) values (7, NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO AR (C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15) values (8, NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO AR (C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15) values (9, NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO AR (C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15) values (10,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL);
INSERT INTO AR (C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15) values (11,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL);
INSERT INTO AR (C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15) values (12,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL);
INSERT INTO AR (C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15) values (13,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL);
INSERT INTO AR (C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15) values (14,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL);
INSERT INTO AR (C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15) values (15,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'');

COMMIT WORK;

/* Table: COUNTRY, Owner: SYSDBA */
CREATE TABLE COUNTRY 
(
    COUNTRY COUNTRYNAME NOT NULL,
    CURRENCY VARCHAR(10) NOT NULL,
CONSTRAINT RDB$PRIMARY1 PRIMARY KEY (COUNTRY)
);
COMMIT WORK;

CREATE TRIGGER TR_MULTI FOR COUNTRY
  ACTIVE
  AFTER INSERT
  POSITION 0 
AS
BEGIN
  POST_EVENT 'MULTI TRIGGERS NOT IMPLEMENTED';
END;

COMMIT WORK;

INSERT INTO COUNTRY (COUNTRY,CURRENCY) values ('USA','Dollar');
INSERT INTO COUNTRY (COUNTRY,CURRENCY) values ('England','Pound');
INSERT INTO COUNTRY (COUNTRY,CURRENCY) values ('Canada','CdnDlr');
INSERT INTO COUNTRY (COUNTRY,CURRENCY) values ('Switzerland','SFranc');
INSERT INTO COUNTRY (COUNTRY,CURRENCY) values ('Japan','Yen');
INSERT INTO COUNTRY (COUNTRY,CURRENCY) values ('Italy','Lira');
INSERT INTO COUNTRY (COUNTRY,CURRENCY) values ('France','FFranc');
INSERT INTO COUNTRY (COUNTRY,CURRENCY) values ('Germany','D-Mark');
INSERT INTO COUNTRY (COUNTRY,CURRENCY) values ('Australia','ADollar');
INSERT INTO COUNTRY (COUNTRY,CURRENCY) values ('Hong Kong','HKDollar');
INSERT INTO COUNTRY (COUNTRY,CURRENCY) values ('Netherlands','Guilder');
INSERT INTO COUNTRY (COUNTRY,CURRENCY) values ('Belgium','BFranc');
INSERT INTO COUNTRY (COUNTRY,CURRENCY) values ('Austria','Schilling');
INSERT INTO COUNTRY (COUNTRY,CURRENCY) values ('Fiji','FDollar');

COMMIT WORK;

/* Table: CUSTOMER, Owner: SYSDBA */
CREATE TABLE CUSTOMER 
(
    CUST_NO CUSTNO NOT NULL,
    CUSTOMER VARCHAR(25) NOT NULL,
    CONTACT_FIRST FIRSTNAME,
    CONTACT_LAST LASTNAME,
    PHONE_NO PHONENUMBER,
    ADDRESS_LINE1 ADDRESSLINE,
    ADDRESS_LINE2 ADDRESSLINE,
    CITY VARCHAR(25),
    STATE_PROVINCE VARCHAR(15),
    COUNTRY COUNTRYNAME,
    POSTAL_CODE VARCHAR(12),
    ON_HOLD CHAR(1),
CONSTRAINT RDB$PRIMARY22 PRIMARY KEY (CUST_NO)
);

COMMIT WORK;

CREATE GENERATOR cust_no_gen;

CREATE TRIGGER SET_CUST_NO FOR CUSTOMER
  ACTIVE
  BEFORE INSERT
  POSITION 0
AS
BEGIN
  if (new.cust_no is null) then
  new.cust_no = gen_id(cust_no_gen, 1);
END;

COMMIT WORK;

INSERT INTO CUSTOMER (CUST_NO,CUSTOMER,CONTACT_FIRST,CONTACT_LAST,PHONE_NO,ADDRESS_LINE1,ADDRESS_LINE2,CITY,STATE_PROVINCE,COUNTRY,POSTAL_CODE,ON_HOLD) values (1001,'Signature Design','Dale J.','Little','(619) 530-2710','15500 Pacific Heights Blvd.',NULL,'San Diego','CA','USA','92121',NULL);
INSERT INTO CUSTOMER (CUST_NO,CUSTOMER,CONTACT_FIRST,CONTACT_LAST,PHONE_NO,ADDRESS_LINE1,ADDRESS_LINE2,CITY,STATE_PROVINCE,COUNTRY,POSTAL_CODE,ON_HOLD) values (1002,'Dallas Technologies','Glen','Brown','(214) 960-2233','P. O. Box 47000',NULL,'Dallas','TX','USA','75205','*');
INSERT INTO CUSTOMER (CUST_NO,CUSTOMER,CONTACT_FIRST,CONTACT_LAST,PHONE_NO,ADDRESS_LINE1,ADDRESS_LINE2,CITY,STATE_PROVINCE,COUNTRY,POSTAL_CODE,ON_HOLD) values (1003,'Buttle, Griffith and Co.','James','Buttle','(617) 488-1864','2300 Newbury Street','Suite 101','Boston','MA','USA','02115',NULL);
INSERT INTO CUSTOMER (CUST_NO,CUSTOMER,CONTACT_FIRST,CONTACT_LAST,PHONE_NO,ADDRESS_LINE1,ADDRESS_LINE2,CITY,STATE_PROVINCE,COUNTRY,POSTAL_CODE,ON_HOLD) values (1004,'Central Bank','Elizabeth','Brocket','61 211 99 88','66 Lloyd Street',NULL,'Manchester',NULL,'England','M2 3LA',NULL);
INSERT INTO CUSTOMER (CUST_NO,CUSTOMER,CONTACT_FIRST,CONTACT_LAST,PHONE_NO,ADDRESS_LINE1,ADDRESS_LINE2,CITY,STATE_PROVINCE,COUNTRY,POSTAL_CODE,ON_HOLD) values (1005,'DT Systems, LTD.','Tai','Wu','(852) 850 43 98','400 Connaught Road',NULL,'Central Hong Kong',NULL,'Hong Kong',NULL,NULL);
INSERT INTO CUSTOMER (CUST_NO,CUSTOMER,CONTACT_FIRST,CONTACT_LAST,PHONE_NO,ADDRESS_LINE1,ADDRESS_LINE2,CITY,STATE_PROVINCE,COUNTRY,POSTAL_CODE,ON_HOLD) values (1006,'DataServe International','Tomas','Bright','(613) 229 3323','2000 Carling Avenue','Suite 150','Ottawa','ON','Canada','K1V 9G1',NULL);
INSERT INTO CUSTOMER (CUST_NO,CUSTOMER,CONTACT_FIRST,CONTACT_LAST,PHONE_NO,ADDRESS_LINE1,ADDRESS_LINE2,CITY,STATE_PROVINCE,COUNTRY,POSTAL_CODE,ON_HOLD) values (1007,'Mrs. Beauvais',NULL,'Mrs. Beauvais',NULL,'P.O. Box 22743',NULL,'Pebble Beach','CA','USA','93953',NULL);
INSERT INTO CUSTOMER (CUST_NO,CUSTOMER,CONTACT_FIRST,CONTACT_LAST,PHONE_NO,ADDRESS_LINE1,ADDRESS_LINE2,CITY,STATE_PROVINCE,COUNTRY,POSTAL_CODE,ON_HOLD) values (1008,'Anini Vacation Rentals','Leilani','Briggs','(808) 835-7605','3320 Lawai Road',NULL,'Lihue','HI','USA','96766',NULL);
INSERT INTO CUSTOMER (CUST_NO,CUSTOMER,CONTACT_FIRST,CONTACT_LAST,PHONE_NO,ADDRESS_LINE1,ADDRESS_LINE2,CITY,STATE_PROVINCE,COUNTRY,POSTAL_CODE,ON_HOLD) values (1009,'Max','Max',NULL,'22 01 23','1 Emerald Cove',NULL,'Turtle Island',NULL,'Fiji',NULL,'*');
INSERT INTO CUSTOMER (CUST_NO,CUSTOMER,CONTACT_FIRST,CONTACT_LAST,PHONE_NO,ADDRESS_LINE1,ADDRESS_LINE2,CITY,STATE_PROVINCE,COUNTRY,POSTAL_CODE,ON_HOLD) values (1010,'MPM Corporation','Miwako','Miyamoto','3 880 77 19','2-64-7 Sasazuka',NULL,'Tokyo',NULL,'Japan','150',NULL);
INSERT INTO CUSTOMER (CUST_NO,CUSTOMER,CONTACT_FIRST,CONTACT_LAST,PHONE_NO,ADDRESS_LINE1,ADDRESS_LINE2,CITY,STATE_PROVINCE,COUNTRY,POSTAL_CODE,ON_HOLD) values (1011,'Dynamic Intelligence Corp','Victor','Granges','01 221 16 50','Florhofgasse 10',NULL,'Zurich',NULL,'Switzerland','8005',NULL);
INSERT INTO CUSTOMER (CUST_NO,CUSTOMER,CONTACT_FIRST,CONTACT_LAST,PHONE_NO,ADDRESS_LINE1,ADDRESS_LINE2,CITY,STATE_PROVINCE,COUNTRY,POSTAL_CODE,ON_HOLD) values (1012,'3D-Pad Corp.','Michelle','Roche','1 43 60 61','22 Place de la Concorde',NULL,'Paris',NULL,'France','75008',NULL);
INSERT INTO CUSTOMER (CUST_NO,CUSTOMER,CONTACT_FIRST,CONTACT_LAST,PHONE_NO,ADDRESS_LINE1,ADDRESS_LINE2,CITY,STATE_PROVINCE,COUNTRY,POSTAL_CODE,ON_HOLD) values (1013,'Lorenzi Export, Ltd.','Andreas','Lorenzi','02 404 6284','Via Eugenia, 15',NULL,'Milan',NULL,'Italy','20124',NULL);
INSERT INTO CUSTOMER (CUST_NO,CUSTOMER,CONTACT_FIRST,CONTACT_LAST,PHONE_NO,ADDRESS_LINE1,ADDRESS_LINE2,CITY,STATE_PROVINCE,COUNTRY,POSTAL_CODE,ON_HOLD) values (1014,'Dyno Consulting','Greta','Hessels','02 500 5940','Rue Royale 350',NULL,'Brussels',NULL,'Belgium','1210',NULL);
INSERT INTO CUSTOMER (CUST_NO,CUSTOMER,CONTACT_FIRST,CONTACT_LAST,PHONE_NO,ADDRESS_LINE1,ADDRESS_LINE2,CITY,STATE_PROVINCE,COUNTRY,POSTAL_CODE,ON_HOLD) values (1015,'GeoTech Inc.','K.M.','Neppelenbroek','(070) 44 91 18','P.0.Box 702',NULL,'Den Haag',NULL,'Netherlands','2514',NULL);

/* Table: DEPARTMENT, Owner: SYSDBA */
CREATE TABLE DEPARTMENT 
(
    DEPT_NO DEPTNO NOT NULL,
    DEPARTMENT VARCHAR(25) NOT NULL,
    HEAD_DEPT DEPTNO,
    MNGR_NO EMPNO,
    BUDGET BUDGET,
    LOCATION VARCHAR(15),
    PHONE_NO PHONENUMBER DEFAULT '555-1234',
CONSTRAINT RDB$PRIMARY5 PRIMARY KEY (DEPT_NO)
);

INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('000','Corporate Headquarters',NULL,105,1000000.00,'Monterey','(408) 555-1234');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('100','Sales and Marketing','000',85,2000000.00,'San Francisco','(415) 555-1234');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('600','Engineering','000',2,1100000.00,'Monterey','(408) 555-1234');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('900','Finance','000',46,400000.00,'Monterey','(408) 555-1234');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('180','Marketing','100',NULL,1500000.00,'San Francisco','(415) 555-1234');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('620','Software Products Div.','600',NULL,1200000.00,'Monterey','(408) 555-1234');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('621','Software Development','620',NULL,400000.00,'Monterey','(408) 555-1234');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('622','Quality Assurance','620',9,300000.00,'Monterey','(408) 555-1234');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('623','Customer Support','620',15,650000.00,'Monterey','(408) 555-1234');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('670','Consumer Electronics Div.','600',107,1150000.00,'Burlington, VT','(802) 555-1234');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('671','Research and Development','670',20,460000.00,'Burlington, VT','(802) 555-1234');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('672','Customer Services','670',94,850000.00,'Burlington, VT','(802) 555-1234');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('130','Field Office: East Coast','100',11,500000.00,'Boston','(617) 555-1234');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('140','Field Office: Canada','100',72,500000.00,'Toronto','(416) 677-1000');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('110','Pacific Rim Headquarters','100',34,600000.00,'Kuaui','(808) 555-1234');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('115','Field Office: Japan','110',118,500000.00,'Tokyo','3 5350 0901');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('116','Field Office: Singapore','110',NULL,300000.00,'Singapore','3 55 1234');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('120','European Headquarters','100',36,700000.00,'London','71 235-4400');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('121','Field Office: Switzerland','120',141,500000.00,'Zurich','1 211 7767');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('123','Field Office: France','120',134,400000.00,'Cannes','58 68 11 12');
INSERT INTO DEPARTMENT (DEPT_NO,DEPARTMENT,HEAD_DEPT,MNGR_NO,BUDGET,LOCATION,PHONE_NO) values ('125','Field Office: Italy','120',121,400000.00,'Milan','2 430 39 39');

/* Table: EMPLOYEE, Owner: SYSDBA */
CREATE TABLE EMPLOYEE 
(
    EMP_NO EMPNO NOT NULL,
    FIRST_NAME FIRSTNAME NOT NULL,
    LAST_NAME LASTNAME NOT NULL,
    PHONE_EXT VARCHAR(4),
    HIRE_DATE TIMESTAMP DEFAULT current_timestamp NOT NULL,
    DEPT_NO DEPTNO NOT NULL,
    JOB_CODE JOBCODE NOT NULL,
    JOB_GRADE JOBGRADE NOT NULL,
    JOB_COUNTRY COUNTRYNAME NOT NULL,
    SALARY SALARY NOT NULL,
    FULL_NAME COMPUTED BY (LAST_NAME || ', ' || FIRST_NAME),
CONSTRAINT RDB$PRIMARY7 PRIMARY KEY (EMP_NO)
);

COMMIT WORK;


CREATE GENERATOR emp_no_gen;

CREATE TRIGGER SET_EMP_NO FOR EMPLOYEE
  ACTIVE
  BEFORE INSERT
  POSITION 0
AS
BEGIN
  if (new.emp_no is null) then
  new.emp_no = gen_id(emp_no_gen, 1);
END;

COMMIT WORK;

INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (2,'Robert','Nelson','250','28.12.1988 00:00:00','600','VP',2,'USA',105900.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (4,'Bruce','Young','233','28.12.1988 00:00:00','621','Eng',2,'USA',97500.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (5,'Kim','Lambert','22','06.02.1989 00:00:00','130','Eng',2,'USA',102750.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (8,'Leslie','Johnson','410','05.04.1989 00:00:00','180','Mktg',3,'USA',64635.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (9,'Phil','Forest','229','17.04.1989 00:00:00','622','Mngr',3,'USA',75060.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (11,'K. J.','Weston','34','17.01.1990 00:00:00','130','SRep',4,'USA',86292.94);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (12,'Terri','Lee','256','01.05.1990 00:00:00','000','Admin',4,'USA',53793.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (14,'Stewart','Hall','227','04.06.1990 00:00:00','900','Finan',3,'USA',69482.63);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (15,'Katherine','Young','231','14.06.1990 00:00:00','623','Mngr',3,'USA',67241.25);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (20,'Chris','Papadopoulos','887','01.01.1990 00:00:00','671','Mngr',3,'USA',89655.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (24,'Pete','Fisher','888','12.09.1990 00:00:00','671','Eng',3,'USA',81810.19);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (28,'Ann','Bennet','5','01.02.1991 00:00:00','120','Admin',5,'England',22935.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (29,'Roger','De Souza','288','18.02.1991 00:00:00','623','Eng',3,'USA',69482.63);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (34,'Janet','Baldwin','2','21.03.1991 00:00:00','110','Sales',3,'USA',61637.81);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (36,'Roger','Reeves','6','25.04.1991 00:00:00','120','Sales',3,'England',33620.63);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (37,'Willie','Stansbury','7','25.04.1991 00:00:00','120','Eng',4,'England',39224.06);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (44,'Leslie','Phong','216','03.06.1991 00:00:00','623','Eng',4,'USA',56034.38);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (45,'Ashok','Ramanathan','209','01.08.1991 00:00:00','621','Eng',3,'USA',80689.50);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (46,'Walter','Steadman','210','09.08.1991 00:00:00','900','CFO',1,'USA',116100.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (52,'Carol','Nordstrom','420','02.10.1991 00:00:00','180','PRel',4,'USA',42742.50);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (61,'Luke','Leung','3','18.02.1992 00:00:00','110','SRep',4,'USA',68805.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (65,'Sue Anne','O''Brien','877','23.03.1992 00:00:00','670','Admin',5,'USA',31275.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (71,'Jennifer M.','Burbank','289','15.04.1992 00:00:00','622','Eng',3,'USA',53167.50);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (72,'Claudia','Sutherland',NULL,'20.04.1992 00:00:00','140','SRep',4,'Canada',100914.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (83,'Dana','Bishop','290','01.06.1992 00:00:00','621','Eng',3,'USA',62550.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (85,'Mary S.','MacDonald','477','01.06.1992 00:00:00','100','VP',2,'USA',111262.50);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (94,'Randy','Williams','892','08.08.1992 00:00:00','672','Mngr',4,'USA',56295.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (105,'Oliver H.','Bender','255','08.10.1992 00:00:00','000','CEO',1,'USA',212850.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (107,'Kevin','Cook','894','01.02.1993 00:00:00','670','Dir',2,'USA',111262.50);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (109,'Kelly','Brown','202','04.02.1993 00:00:00','600','Admin',5,'USA',27000.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (110,'Yuki','Ichida','22','04.02.1993 00:00:00','115','Eng',3,'Japan',6000000.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (113,'Mary','Page','845','12.04.1993 00:00:00','671','Eng',4,'USA',48000.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (114,'Bill','Parker','247','01.06.1993 00:00:00','623','Eng',5,'USA',35000.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (118,'Takashi','Yamamoto','23','01.07.1993 00:00:00','115','SRep',4,'Japan',7480000.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (121,'Roberto','Ferrari','1','12.07.1993 00:00:00','125','SRep',4,'Italy',13100654.08);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (127,'Michael','Yanowski','492','09.08.1993 00:00:00','100','SRep',4,'USA',44000.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (134,'Jacques','Glon',NULL,'23.08.1993 00:00:00','123','SRep',4,'France',390500.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (136,'Scott','Johnson','265','13.09.1993 00:00:00','623','Doc',3,'USA',60000.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (138,'T.J.','Green','218','01.11.1993 00:00:00','621','Eng',4,'USA',36000.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (141,'Pierre','Osborne',NULL,'03.01.1994 00:00:00','121','SRep',4,'Switzerland',110000.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (144,'John','Montgomery','820','30.03.1994 00:00:00','672','Eng',5,'USA',35000.00);
INSERT INTO EMPLOYEE (EMP_NO,FIRST_NAME,LAST_NAME,PHONE_EXT,HIRE_DATE,DEPT_NO,JOB_CODE,JOB_GRADE,JOB_COUNTRY,SALARY) values (145,'Mark','Guckenheimer','221','02.05.1994 00:00:00','622','Eng',5,'USA',32000.00);

COMMIT WORK;

/* Table: EMPLOYEE_PROJECT, Owner: SYSDBA */
CREATE TABLE EMPLOYEE_PROJECT 
(
    EMP_NO EMPNO NOT NULL,
    PROJ_ID PROJNO NOT NULL,
CONSTRAINT RDB$PRIMARY14 PRIMARY KEY (EMP_NO, PROJ_ID)
);

COMMIT WORK;

INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (144,'DGPII');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (113,'DGPII');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (24,'DGPII');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (8,'VBASE');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (136,'VBASE');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (15,'VBASE');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (71,'VBASE');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (145,'VBASE');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (44,'VBASE');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (4,'VBASE');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (83,'VBASE');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (138,'VBASE');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (45,'VBASE');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (20,'GUIDE');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (24,'GUIDE');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (113,'GUIDE');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (8,'GUIDE');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (4,'MAPDB');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (71,'MAPDB');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (46,'MKTPR');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (105,'MKTPR');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (12,'MKTPR');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (85,'MKTPR');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (110,'MKTPR');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (34,'MKTPR');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (8,'MKTPR');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (14,'MKTPR');
INSERT INTO EMPLOYEE_PROJECT (EMP_NO,PROJ_ID) values (52,'MKTPR');


/* Table: JOB, Owner: SYSDBA */
CREATE TABLE JOB 
(
    JOB_CODE VARCHAR(5) NOT NULL,
    JOB_GRADE JOBGRADE NOT NULL,
    JOB_COUNTRY COUNTRYNAME NOT NULL,
    JOB_TITLE VARCHAR(25) NOT NULL,
    MIN_SALARY SALARY NOT NULL,
    MAX_SALARY SALARY NOT NULL,
    JOB_REQUIREMENT BLOB SUB_TYPE TEXT SEGMENT SIZE 80,
    LANGUAGE_REQ VARCHAR(255)[5],
CONSTRAINT RDB$PRIMARY2 PRIMARY KEY (JOB_CODE, JOB_GRADE, JOB_COUNTRY)
);

INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('CEO',1,'USA','Chief Executive Officer',130000.00,250000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('CFO',1,'USA','Chief Financial Officer',85000.00,140000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('VP',2,'USA','Vice President',80000.00,130000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Dir',2,'USA','Director',75000.00,120000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Mngr',3,'USA','Manager',60000.00,100000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Mngr',4,'USA','Manager',30000.00,60000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Admin',4,'USA','Administrative Assistant',35000.00,55000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Admin',5,'USA','Administrative Assistant',20000.00,40000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Admin',5,'England','Administrative Assistant',13400.00,26800.00,NULL,NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('PRel',4,'USA','Public Relations Rep.',25000.00,65000.00,NULL,NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Mktg',3,'USA','Marketing Analyst',40000.00,80000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Mktg',4,'USA','Marketing Analyst',20000.00,50000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Accnt',4,'USA','Accountant',28000.00,55000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Finan',3,'USA','Financial Analyst',35000.00,85000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Eng',2,'USA','Engineer',70000.00,110000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Eng',3,'USA','Engineer',50000.00,90000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Eng',3,'Japan','Engineer',5400000.00,9720000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Eng',4,'USA','Engineer',30000.00,65000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Eng',4,'England','Engineer',20100.00,43550.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Eng',5,'USA','Engineer',25000.00,35000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Doc',3,'USA','Technical Writer',38000.00,60000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Doc',5,'USA','Technical Writer',22000.00,40000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Sales',3,'USA','Sales Co-ordinator',40000.00,70000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('Sales',3,'England','Sales Co-ordinator',26800.00,46900.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('SRep',4,'USA','Sales Representative',20000.00,100000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('SRep',4,'England','Sales Representative',13400.00,67000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('SRep',4,'Canada','Sales Representative',26400.00,132000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('SRep',4,'Switzerland','Sales Representative',28000.00,149000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('SRep',4,'Japan','Sales Representative',2160000.00,10800000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('SRep',4,'Italy','Sales Representative',33600000.00,168000000.00,'',NULL);
INSERT INTO JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY,JOB_TITLE,MIN_SALARY,MAX_SALARY,JOB_REQUIREMENT,LANGUAGE_REQ) values ('SRep',4,'France','Sales Representative',118200.00,591000.00,'',NULL);

COMMIT WORK;

/* Table: PROJECT, Owner: SYSDBA */
CREATE TABLE PROJECT 
(
    PROJ_ID PROJNO NOT NULL,
    PROJ_NAME VARCHAR(20) NOT NULL,
    PROJ_DESC BLOB SUB_TYPE TEXT SEGMENT SIZE 80,
    TEAM_LEADER EMPNO,
    PRODUCT PRODTYPE,
CONSTRAINT RDB$PRIMARY12 PRIMARY KEY (PROJ_ID)
);

COMMIT WORK;

INSERT INTO PROJECT (PROJ_ID,PROJ_NAME,PROJ_DESC,TEAM_LEADER,PRODUCT) values ('VBASE','Video Database','',45,'software');
INSERT INTO PROJECT (PROJ_ID,PROJ_NAME,PROJ_DESC,TEAM_LEADER,PRODUCT) values ('DGPII','DigiPizza','',24,'other');
INSERT INTO PROJECT (PROJ_ID,PROJ_NAME,PROJ_DESC,TEAM_LEADER,PRODUCT) values ('GUIDE','AutoMap','',20,'hardware');
INSERT INTO PROJECT (PROJ_ID,PROJ_NAME,PROJ_DESC,TEAM_LEADER,PRODUCT) values ('MAPDB','MapBrowser port','',4,'software');
INSERT INTO PROJECT (PROJ_ID,PROJ_NAME,PROJ_DESC,TEAM_LEADER,PRODUCT) values ('HWRII','Translator upgrade','',NULL,'software');
INSERT INTO PROJECT (PROJ_ID,PROJ_NAME,PROJ_DESC,TEAM_LEADER,PRODUCT) values ('MKTPR','Marketing project 3','',85,'N/A');

COMMIT WORK;

/* Table: PROJ_DEPT_BUDGET, Owner: SYSDBA */
CREATE TABLE PROJ_DEPT_BUDGET 
(
    FISCAL_YEAR INTEGER NOT NULL,
    PROJ_ID PROJNO NOT NULL,
    DEPT_NO DEPTNO NOT NULL,
    QUART_HEAD_CNT INTEGER[4],
    PROJECTED_BUDGET BUDGET,
CONSTRAINT RDB$PRIMARY17 PRIMARY KEY (FISCAL_YEAR, PROJ_ID, DEPT_NO)
);

INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'GUIDE','100','',200000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'GUIDE','671','',450000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1993,'MAPDB','621','',20000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'MAPDB','621','',40000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'MAPDB','622','',60000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'MAPDB','671','',11000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'HWRII','670','',20000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'HWRII','621','',400000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'HWRII','622','',100000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'MKTPR','623','',80000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'MKTPR','672','',100000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'MKTPR','100','',1000000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'MKTPR','110','',200000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'MKTPR','000','',100000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1995,'MKTPR','623','',1200000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1995,'MKTPR','672','',800000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1995,'MKTPR','100','',2000000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1995,'MKTPR','110','',1200000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'VBASE','621','',1900000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1995,'VBASE','621','',900000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'VBASE','622','',400000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1994,'VBASE','100','',300000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1995,'VBASE','100','',1500000.00);
INSERT INTO PROJ_DEPT_BUDGET (FISCAL_YEAR,PROJ_ID,DEPT_NO,QUART_HEAD_CNT,PROJECTED_BUDGET) values (1996,'VBASE','100','',150000.00);


/* Table: SALARY_HISTORY, Owner: SYSDBA */
CREATE TABLE SALARY_HISTORY 
(
    EMP_NO EMPNO NOT NULL,
    CHANGE_DATE TIMESTAMP DEFAULT current_timestamp NOT NULL,
    UPDATER_ID VARCHAR(20) NOT NULL,
    OLD_SALARY SALARY NOT NULL,
    PERCENT_CHANGE DOUBLE PRECISION DEFAULT 0 NOT NULL,
    NEW_SALARY COMPUTED BY (old_salary + old_salary * percent_change / 100),
CONSTRAINT RDB$PRIMARY20 PRIMARY KEY (EMP_NO, CHANGE_DATE, UPDATER_ID)
);

COMMIT WORK;

CREATE TRIGGER SAVE_SALARY_CHANGE FOR EMPLOYEE
  ACTIVE
  AFTER UPDATE
  POSITION 0
AS
BEGIN
  IF (old.salary <> new.salary) THEN
    INSERT INTO salary_history
      (emp_no, change_date, updater_id, old_salary, percent_change)
    VALUES (
      old.emp_no,
      'NOW',
      user,
      old.salary,
      (new.salary - old.salary) * 100 / old.salary);
END;

COMMIT WORK;

INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (28,'15.12.1992 00:00:00','admin2',20000.00,10.);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (2,'15.12.1992 00:00:00','admin2',98000.00,8.0611999999999995);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (4,'15.12.1992 00:00:00','admin2',90000.00,8.3332999999999995);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (5,'15.12.1992 00:00:00','admin2',95000.00,8.1577999999999999);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (11,'15.12.1992 00:00:00','admin2',70000.00,7.5);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (12,'15.12.1992 00:00:00','admin2',48000.00,7.5);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (14,'15.12.1992 00:00:00','admin2',62000.00,7.5);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (15,'15.12.1992 00:00:00','admin2',60000.00,7.5);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (20,'15.12.1992 00:00:00','admin2',80000.00,7.5);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (24,'15.12.1992 00:00:00','admin2',73000.00,7.5);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (29,'15.12.1992 00:00:00','admin2',62000.00,7.5);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (34,'15.12.1992 00:00:00','admin2',55000.00,7.5);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (36,'15.12.1992 00:00:00','admin2',30000.00,7.5);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (37,'15.12.1992 00:00:00','admin2',35000.00,7.5);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (44,'15.12.1992 00:00:00','admin2',50000.00,7.5);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (45,'15.12.1992 00:00:00','admin2',72000.00,7.5);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (8,'08.09.1993 00:00:00','elaine',62000.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (9,'08.09.1993 00:00:00','elaine',72000.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (11,'08.09.1993 00:00:00','elaine',75250.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (12,'08.09.1993 00:00:00','elaine',51600.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (14,'08.09.1993 00:00:00','elaine',66650.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (15,'08.09.1993 00:00:00','elaine',64500.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (20,'08.09.1993 00:00:00','elaine',86000.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (24,'08.09.1993 00:00:00','elaine',78475.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (28,'08.09.1993 00:00:00','elaine',22000.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (29,'08.09.1993 00:00:00','elaine',66650.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (34,'08.09.1993 00:00:00','elaine',59125.00,4.2499000000000002);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (36,'08.09.1993 00:00:00','elaine',32250.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (37,'08.09.1993 00:00:00','elaine',37625.00,4.2499000000000002);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (44,'08.09.1993 00:00:00','elaine',53750.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (45,'08.09.1993 00:00:00','elaine',77400.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (52,'08.09.1993 00:00:00','elaine',41000.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (61,'08.09.1993 00:00:00','elaine',60000.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (65,'08.09.1993 00:00:00','elaine',30000.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (71,'08.09.1993 00:00:00','elaine',51000.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (72,'08.09.1993 00:00:00','elaine',88000.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (83,'08.09.1993 00:00:00','elaine',60000.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (94,'08.09.1993 00:00:00','elaine',54000.00,4.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (46,'20.12.1993 00:00:00','tj',120000.00,-3.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (85,'20.12.1993 00:00:00','tj',115000.00,-3.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (105,'20.12.1993 00:00:00','tj',220000.00,-3.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (107,'20.12.1993 00:00:00','tj',115000.00,-3.25);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (11,'20.12.1993 00:00:00','elaine',78448.13,9.9999000000000002);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (61,'20.12.1993 00:00:00','elaine',62550.00,10.);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (72,'20.12.1993 00:00:00','elaine',91740.00,10.);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (121,'20.12.1993 00:00:00','elaine',4100654.08,10.);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (118,'20.12.1993 00:00:00','elaine',6800000.00,10.);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (127,'20.12.1993 00:00:00','elaine',40000.00,10.);
INSERT INTO SALARY_HISTORY (EMP_NO,CHANGE_DATE,UPDATER_ID,OLD_SALARY,PERCENT_CHANGE) values (134,'20.12.1993 00:00:00','elaine',355000.00,10.);

COMMIT WORK;

/* Table: SALES, Owner: SYSDBA */
CREATE TABLE SALES 
(
    PO_NUMBER PONUMBER NOT NULL,
    CUST_NO CUSTNO NOT NULL,
    SALES_REP EMPNO,
    ORDER_STATUS VARCHAR(7) DEFAULT 'new' NOT NULL,
    ORDER_DATE TIMESTAMP DEFAULT current_timestamp NOT NULL,
    SHIP_DATE TIMESTAMP,
    DATE_NEEDED TIMESTAMP,
    PAID CHAR(1) DEFAULT 'n',
    QTY_ORDERED INTEGER DEFAULT 1 NOT NULL,
    TOTAL_VALUE DECIMAL(9, 2) NOT NULL,
    DISCOUNT FLOAT DEFAULT 0 NOT NULL,
    ITEM_TYPE PRODTYPE,
    AGED Computed by (ship_date - order_date),
CONSTRAINT RDB$PRIMARY24 PRIMARY KEY (PO_NUMBER)
);

COMMIT WORK;

CREATE TRIGGER POST_NEW_ORDER FOR SALES
  ACTIVE
  AFTER INSERT
  POSITION 0
AS
BEGIN
  POST_EVENT 'new_order';
END;

COMMIT WORK;

INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V91E0210',1004,11,'shipped','04.03.1991 00:00:00','05.03.1991 00:00:00',NULL,'y',10,5000.00,0.10000000149011612,'hardware');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V92E0340',1004,11,'shipped','15.10.1992 00:00:00','16.10.1992 00:00:00','17.10.1992 00:00:00','y',7,70000.00,0.,'hardware');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V92J1003',1010,61,'shipped','26.07.1992 00:00:00','04.08.1992 00:00:00','15.09.1992 00:00:00','y',15,2985.00,0.,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V93J2004',1010,118,'shipped','30.10.1993 00:00:00','02.12.1993 00:00:00','15.11.1993 00:00:00','y',3,210.00,0.,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V93J3100',1010,118,'shipped','20.08.1993 00:00:00','20.08.1993 00:00:00',NULL,'y',16,18000.40,0.10000000149011612,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V92F3004',1012,11,'shipped','15.10.1992 00:00:00','16.01.1993 00:00:00','16.01.1993 00:00:00','y',3,2000.00,0.,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V93F3088',1012,134,'shipped','27.08.1993 00:00:00','08.09.1993 00:00:00',NULL,'n',10,10000.00,0.,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V93F2030',1012,134,'open','12.12.1993 00:00:00',NULL,NULL,'y',15,450000.49,0.,'hardware');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V93F2051',1012,134,'waiting','18.12.1993 00:00:00',NULL,'01.03.1994 00:00:00','n',1,999.98,0.,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V93H0030',1005,118,'open','12.12.1993 00:00:00',NULL,'01.01.1994 00:00:00','y',20,5980.00,0.20000000298023224,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V94H0079',1005,61,'open','13.02.1994 00:00:00',NULL,'20.04.1994 00:00:00','n',10,9000.00,5.000000074505806e-002,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V9324200',1001,72,'shipped','09.08.1993 00:00:00','09.08.1993 00:00:00','17.08.1993 00:00:00','y',1000,560000.00,0.20000000298023224,'hardware');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V9324320',1001,127,'shipped','16.08.1993 00:00:00','16.08.1993 00:00:00','01.09.1993 00:00:00','y',1,0.00,1.,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V9320630',1001,127,'open','12.12.1993 00:00:00',NULL,'15.12.1993 00:00:00','n',3,60000.00,0.20000000298023224,'hardware');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V9420099',1001,127,'open','17.01.1994 00:00:00',NULL,'01.06.1994 00:00:00','n',100,3399.15,0.15000000596046448,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V9427029',1001,127,'shipped','07.02.1994 00:00:00','10.02.1994 00:00:00','10.02.1994 00:00:00','n',17,422210.97,0.,'hardware');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V9333005',1002,11,'shipped','03.02.1993 00:00:00','03.03.1993 00:00:00',NULL,'y',2,600.50,0.,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V9333006',1002,11,'shipped','27.04.1993 00:00:00','02.05.1993 00:00:00','02.05.1993 00:00:00','n',5,20000.00,0.,'other');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V9336100',1002,11,'waiting','27.12.1993 00:00:00','01.01.1994 00:00:00','01.01.1994 00:00:00','n',150,14850.00,5.000000074505806e-002,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V9346200',1003,11,'waiting','31.12.1993 00:00:00',NULL,'24.01.1994 00:00:00','n',3,0.00,1.,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V9345200',1003,11,'shipped','11.11.1993 00:00:00','02.12.1993 00:00:00','01.12.1993 00:00:00','y',900,27000.00,0.30000001192092896,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V9345139',1003,127,'shipped','09.09.1993 00:00:00','20.09.1993 00:00:00','01.10.1993 00:00:00','y',20,12582.12,0.10000000149011612,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V93C0120',1006,72,'shipped','22.03.1993 00:00:00','31.05.1993 00:00:00','17.04.1993 00:00:00','y',1,47.50,0.,'other');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V93C0990',1006,72,'shipped','09.08.1993 00:00:00','02.09.1993 00:00:00',NULL,'y',40,399960.50,0.10000000149011612,'hardware');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V9456220',1007,127,'open','04.01.1994 00:00:00',NULL,'30.01.1994 00:00:00','y',1,3999.99,0.,'hardware');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V93S4702',1011,121,'shipped','27.10.1993 00:00:00','28.10.1993 00:00:00','15.12.1993 00:00:00','y',4,120000.00,0.,'hardware');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V94S6400',1011,141,'waiting','06.01.1994 00:00:00',NULL,'15.02.1994 00:00:00','y',20,1980.72,0.40000000596046448,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V93H3009',1008,61,'shipped','01.08.1993 00:00:00','02.12.1993 00:00:00','01.12.1993 00:00:00','n',3,9000.00,5.000000074505806e-002,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V93H0500',1008,61,'open','12.12.1993 00:00:00',NULL,'15.12.1993 00:00:00','n',3,16000.00,0.20000000298023224,'hardware');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V93F0020',1009,61,'shipped','10.10.1993 00:00:00','11.11.1993 00:00:00','11.11.1993 00:00:00','n',1,490.69,0.,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V93I4700',1013,121,'open','27.10.1993 00:00:00',NULL,'15.12.1993 00:00:00','n',5,2693.00,0.,'hardware');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V93B1002',1014,134,'shipped','20.09.1993 00:00:00','21.09.1993 00:00:00','25.09.1993 00:00:00','y',1,100.02,0.,'software');
INSERT INTO SALES (PO_NUMBER,CUST_NO,SALES_REP,ORDER_STATUS,ORDER_DATE,SHIP_DATE,DATE_NEEDED,PAID,QTY_ORDERED,TOTAL_VALUE,DISCOUNT,ITEM_TYPE) values ('V93N5822',1015,134,'shipped','18.12.1993 00:00:00','14.01.1994 00:00:00',NULL,'n',2,1500.00,0.,'software');

/* Table: T, Owner: SYSDBA */
CREATE TABLE T 
(
    C1 INTEGER
);

/* Table: T2, Owner: SYSDBA */
CREATE TABLE T2 
(
    C1 SMALLINT,
    C2 INTEGER,
    C3 INTEGER,
    C4 CHAR(5),
    C5 VARCHAR(10),
    C6 TIMESTAMP,
    C7 TIMESTAMP,
    C8 TIMESTAMP,
    C9 BLOB SUB_TYPE TEXT SEGMENT SIZE 80,
    C10 DECIMAL(18, 2),
    C11 DECIMAL(18, 2),
    C12 FLOAT,
    C13 DOUBLE PRECISION,
    C14 DECIMAL(8, 4),
    C15 DECIMAL(8, 4),
    C16 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    C17 BOOLEAN DEFAULT FALSE
);

/* Table: T3, Owner: SYSDBA */
CREATE TABLE T3 
(
    C1 INTEGER,
    C2 CHAR(10) CHARACTER SET UTF8,
    C3 VARCHAR(10) CHARACTER SET UTF8,
    C4 BLOB SUB_TYPE TEXT SEGMENT SIZE 80 CHARACTER SET UTF8,
    C5 BLOB SUB_TYPE 0 SEGMENT SIZE 80
);

/* Table: T4, Owner: SYSDBA */
CREATE TABLE T4 
(
    C1 INTEGER,
    C_OCTETS CHAR(5) CHARACTER SET OCTETS,
    V_OCTETS VARCHAR(30) CHARACTER SET OCTETS,
    C_NONE CHAR(5),
    V_NONE VARCHAR(30),
    C_WIN1250 CHAR(5) CHARACTER SET WIN1250,
    V_WIN1250 VARCHAR(30) CHARACTER SET WIN1250,
    C_UTF8 CHAR(5) CHARACTER SET UTF8,
    V_UTF8 VARCHAR(30) CHARACTER SET UTF8
);

/* Stored Procedure: LOWER, Owner: SYSDBA */

CREATE PROCEDURE LOWER (
  IN_PARAM VARCHAR(50))
RETURNS (
  OUT_PARAM VARCHAR(50))
AS
BEGIN
  OUT_PARAM = IN_PARAM;
  SUSPEND;
END;

/*  Index definitions for all user tables */

CREATE INDEX CUSTNAMEX ON CUSTOMER(CUSTOMER);
CREATE INDEX CUSTREGION ON CUSTOMER(COUNTRY, CITY);
CREATE INDEX RDB$FOREIGN23 ON CUSTOMER(COUNTRY);
CREATE INDEX BUDGETX ON DEPARTMENT(BUDGET);
CREATE UNIQUE INDEX RDB$4 ON DEPARTMENT(DEPARTMENT);
CREATE INDEX RDB$FOREIGN10 ON DEPARTMENT(MNGR_NO);
CREATE INDEX RDB$FOREIGN6 ON DEPARTMENT(HEAD_DEPT);
CREATE INDEX NAMEX ON EMPLOYEE(LAST_NAME, FIRST_NAME);
CREATE INDEX RDB$FOREIGN8 ON EMPLOYEE(DEPT_NO);
CREATE INDEX RDB$FOREIGN9 ON EMPLOYEE(JOB_CODE, JOB_GRADE, JOB_COUNTRY);
CREATE INDEX RDB$FOREIGN15 ON EMPLOYEE_PROJECT(EMP_NO);
CREATE INDEX RDB$FOREIGN16 ON EMPLOYEE_PROJECT(PROJ_ID);
CREATE INDEX MAXSALX ON JOB(JOB_COUNTRY, MAX_SALARY);
CREATE INDEX MINSALX ON JOB(JOB_COUNTRY, MIN_SALARY);
CREATE INDEX RDB$FOREIGN3 ON JOB(JOB_COUNTRY);
CREATE UNIQUE INDEX PRODTYPEX ON PROJECT(PRODUCT, PROJ_NAME);
CREATE UNIQUE INDEX RDB$11 ON PROJECT(PROJ_NAME);
CREATE INDEX RDB$FOREIGN13 ON PROJECT(TEAM_LEADER);
CREATE INDEX RDB$FOREIGN18 ON PROJ_DEPT_BUDGET(DEPT_NO);
CREATE INDEX RDB$FOREIGN19 ON PROJ_DEPT_BUDGET(PROJ_ID);
CREATE INDEX CHANGEX ON SALARY_HISTORY(CHANGE_DATE);
CREATE INDEX RDB$FOREIGN21 ON SALARY_HISTORY(EMP_NO);
CREATE INDEX UPDATERX ON SALARY_HISTORY(UPDATER_ID);
CREATE INDEX NEEDX ON SALES(DATE_NEEDED);
CREATE INDEX QTYX ON SALES(ITEM_TYPE, QTY_ORDERED);
CREATE INDEX RDB$FOREIGN25 ON SALES(CUST_NO);
CREATE INDEX RDB$FOREIGN26 ON SALES(SALES_REP);
CREATE INDEX SALESTATX ON SALES(ORDER_STATUS, PAID);
ALTER TABLE CUSTOMER ADD FOREIGN KEY (COUNTRY) REFERENCES COUNTRY (COUNTRY);
ALTER TABLE EMPLOYEE_PROJECT ADD FOREIGN KEY (PROJ_ID) REFERENCES PROJECT (PROJ_ID);
ALTER TABLE PROJ_DEPT_BUDGET ADD FOREIGN KEY (PROJ_ID) REFERENCES PROJECT (PROJ_ID);
ALTER TABLE SALARY_HISTORY ADD FOREIGN KEY (EMP_NO) REFERENCES EMPLOYEE (EMP_NO);
ALTER TABLE SALES ADD FOREIGN KEY (CUST_NO) REFERENCES CUSTOMER (CUST_NO);
ALTER TABLE SALES ADD FOREIGN KEY (SALES_REP) REFERENCES EMPLOYEE (EMP_NO);

/* Subscriptions */
SET AUTODDL OFF;
SET AUTODDL ON;
COMMIT;
COMMIT WORK;

/* Stored procedures */
CREATE PROCEDURE ADD_EMP_PROJ
(
  EMP_NO              SMALLINT,
  PROJ_ID               CHAR(5)
)
AS
BEGIN
    BEGIN
    INSERT INTO employee_project (emp_no, proj_id) VALUES (:emp_no, :proj_id);
    WHEN SQLCODE -530 DO
        EXCEPTION unknown_emp_id;
    END
    SUSPEND;
END;


CREATE PROCEDURE SHOW_LANGS
(
  CODE                VARCHAR(5),
  GRADE               SMALLINT,
  CTY                 VARCHAR(15)
)
RETURNS
(
  LANGUAGES             VARCHAR(15)
)
AS
DECLARE VARIABLE i INTEGER;
BEGIN
  i = 1;
  WHILE (i <= 5) DO
  BEGIN
  SELECT language_req[:i] FROM joB
  WHERE ((job_code = :code) AND (job_grade = :grade) AND (job_country = :cty)
       AND (language_req IS NOT NULL))
  INTO :languages;
  IF (languages = ' ') THEN  /* Prints 'NULL' instead of blanks */
     languages = 'NULL';
  i = i +1;
  SUSPEND;
  END
END;

CREATE PROCEDURE ALL_LANGS
RETURNS
(
  CODE                VARCHAR(5),
  GRADE               VARCHAR(5),
  COUNTRY               VARCHAR(15),
  LANG                VARCHAR(15)
)
AS
BEGIN
    FOR SELECT job_code, job_grade, job_country FROM job
        INTO :code, :grade, :country

    DO
    BEGIN
      FOR SELECT languages FROM SHOW_LANGS
          (:code, :grade, :country) INTO :lang DO
        SUSPEND;
      /* Put nice separators between rows */
      code = '=====';
      grade = '=====';
      country = '===============';
      lang = '==============';
      SUSPEND;
    END
END;

CREATE PROCEDURE DELETE_EMPLOYEE
(
  EMP_NUM               INTEGER
)
AS
DECLARE VARIABLE any_sales INTEGER;
BEGIN
    any_sales = 0;

    /*
     *    If there are any sales records referencing this employee,
     *    can't delete the employee until the sales are re-assigned
     *    to another employee or changed to NULL.
     */
    SELECT count(po_number)
    FROM sales
    WHERE sales_rep = :emp_num
    INTO :any_sales;

    IF (any_sales > 0) THEN
    BEGIN
        EXCEPTION reassign_sales;
        SUSPEND;
    END

    /*
     *    If the employee is a manager, update the department.
     */
    UPDATE department
    SET mngr_no = NULL
    WHERE mngr_no = :emp_num;

    /*
     *    If the employee is a project leader, update project.
     */
    UPDATE project
    SET team_leader = NULL
    WHERE team_leader = :emp_num;

    /*
     *    Delete the employee from any projects.
     */
    DELETE FROM employee_project
    WHERE emp_no = :emp_num;

    /*
     *    Delete old salary records.
     */
    DELETE FROM salary_history
    WHERE emp_no = :emp_num;

    /*
     *    Delete the employee.
     */
    DELETE FROM employee
    WHERE emp_no = :emp_num;

    SUSPEND;
END;

CREATE PROCEDURE DEPT_BUDGET
(
  DNO                 CHAR(3)
)
RETURNS
(
  TOT                 DECIMAL(12, 2)
)
AS

DECLARE VARIABLE sumb DECIMAL(12, 2);
    DECLARE VARIABLE rdno CHAR(3);
    DECLARE VARIABLE cnt INTEGER;
BEGIN
    tot = 0;

    SELECT budget FROM department WHERE dept_no = :dno INTO :tot;

    SELECT count(budget) FROM department WHERE head_dept = :dno INTO :cnt;

    IF (cnt = 0) THEN
        SUSPEND;

    FOR SELECT dept_no
        FROM department
        WHERE head_dept = :dno
        INTO :rdno
    DO
        BEGIN
            EXECUTE PROCEDURE dept_budget :rdno RETURNING_VALUES :sumb;
            tot = tot + sumb;
        END

    SUSPEND;
END;

CREATE PROCEDURE GET_EMP_PROJ (EMP_NO SMALLINT)
RETURNS (PROJ_ID CHAR(5))
AS
BEGIN
    FOR SELECT proj_id
        FROM employee_project
        WHERE emp_no = :emp_no
        INTO :proj_id
    DO
        SUSPEND;
END;

CREATE PROCEDURE MAIL_LABEL
(
  CUST_NO               INTEGER
)
RETURNS
(
  LINE1               CHAR(40),
  LINE2               CHAR(40),
  LINE3               CHAR(40),
  LINE4               CHAR(40),
  LINE5               CHAR(40),
  LINE6               CHAR(40)
)
AS

DECLARE VARIABLE customer     VARCHAR(25);
    DECLARE VARIABLE first_name       VARCHAR(15);
    DECLARE VARIABLE last_name        VARCHAR(20);
    DECLARE VARIABLE addr1      VARCHAR(30);
    DECLARE VARIABLE addr2      VARCHAR(30);
    DECLARE VARIABLE city       VARCHAR(25);
    DECLARE VARIABLE state      VARCHAR(15);
    DECLARE VARIABLE country    VARCHAR(15);
    DECLARE VARIABLE postcode     VARCHAR(12);
    DECLARE VARIABLE cnt      INTEGER;
BEGIN
    line1 = '';
    line2 = '';
    line3 = '';
    line4 = '';
    line5 = '';
    line6 = '';

    SELECT customer, contact_first, contact_last, address_line1,
        address_line2, city, state_province, country, postal_code
    FROM CUSTOMER
    WHERE cust_no = :cust_no
    INTO :customer, :first_name, :last_name, :addr1, :addr2,
        :city, :state, :country, :postcode;

    IF (customer IS NOT NULL) THEN
        line1 = customer;
    IF (first_name IS NOT NULL) THEN
        line2 = first_name || ' ' || last_name;
    ELSE
        line2 = last_name;
    IF (addr1 IS NOT NULL) THEN
        line3 = addr1;
    IF (addr2 IS NOT NULL) THEN
        line4 = addr2;

    IF (country = 'USA') THEN
    BEGIN
        IF (city IS NOT NULL) THEN
            line5 = city || ', ' || state || '  ' || postcode;
        ELSE
            line5 = state || '  ' || postcode;
    END
    ELSE
    BEGIN
        IF (city IS NOT NULL) THEN
            line5 = city || ', ' || state;
        ELSE
            line5 = state;
        line6 = country || '  ' || postcode;
    END

    SUSPEND;
END;

CREATE PROCEDURE ORG_CHART
RETURNS
(
  HEAD_DEPT             CHAR(25),
  DEPARTMENT            CHAR(25),
  MNGR_NAME             CHAR(20),
  TITLE                 CHAR(5),
  EMP_CNT               INTEGER
)
AS
DECLARE VARIABLE mngr_no INTEGER;
    DECLARE VARIABLE dno CHAR(3);
BEGIN
    FOR SELECT h.department, d.department, d.mngr_no, d.dept_no
        FROM department d
        LEFT OUTER JOIN department h ON d.head_dept = h.dept_no
        ORDER BY d.dept_no
        INTO :head_dept, :department, :mngr_no, :dno
    DO
    BEGIN
        IF (:mngr_no IS NULL) THEN
        BEGIN
            mngr_name = '--TBH--';
            title = '';
        END

        ELSE
            SELECT full_name, job_code
            FROM employee
            WHERE emp_no = :mngr_no
            INTO :mngr_name, :title;

        SELECT COUNT(emp_no)
        FROM employee
        WHERE dept_no = :dno
        INTO :emp_cnt;

        SUSPEND;
    END
END;


CREATE PROCEDURE SHIP_ORDER
(
  PO_NUM              CHAR(8)
)
AS
DECLARE VARIABLE ord_stat CHAR(7);
DECLARE VARIABLE hold_stat CHAR(1);
DECLARE VARIABLE cust_no INTEGER;
DECLARE VARIABLE any_po CHAR(8);
BEGIN
    SELECT s.order_status, c.on_hold, c.cust_no
    FROM sales s, customer c
    WHERE po_number = :po_num
    AND s.cust_no = c.cust_no
    INTO :ord_stat, :hold_stat, :cust_no;

    /* This purchase order has been already shipped. */
    IF (ord_stat = 'shipped') THEN
    BEGIN
        EXCEPTION order_already_shipped;
        SUSPEND;
    END

    /*    Customer is on hold. */
    ELSE IF (hold_stat = '*') THEN
    BEGIN
        EXCEPTION customer_on_hold;
        SUSPEND;
    END

    /*
     *    If there is an unpaid balance on orders shipped over 2 months ago,
     *    put the customer on hold.
     */
    FOR SELECT po_number
        FROM sales
        WHERE cust_no = :cust_no
        AND order_status = 'shipped'
        AND paid = 'n'
        AND ship_date < CAST('NOW' AS TIMESTAMP) - 60
        INTO :any_po
    DO
    BEGIN
        EXCEPTION customer_check;

        UPDATE customer
        SET on_hold = '*'
        WHERE cust_no = :cust_no;

        SUSPEND;
    END

    /*
     *    Ship the order.
     */
    UPDATE sales
    SET order_status = 'shipped', ship_date = 'NOW'
    WHERE po_number = :po_num;

    SUSPEND;
END;


CREATE PROCEDURE SUB_TOT_BUDGET
(
  HEAD_DEPT             CHAR(3)
)
RETURNS
(
  TOT_BUDGET            DECIMAL(12, 2),
  AVG_BUDGET            DECIMAL(12, 2),
  MIN_BUDGET            DECIMAL(12, 2),
  MAX_BUDGET            DECIMAL(12, 2)
)
AS
BEGIN
    SELECT SUM(budget), AVG(budget), MIN(budget), MAX(budget)
        FROM department
        WHERE head_dept = :head_dept
        INTO :tot_budget, :avg_budget, :min_budget, :max_budget;
    SUSPEND;
END;


COMMIT WORK;

CREATE VIEW PHONE_LIST 
(
  EMP_NO,
  FIRST_NAME,
  LAST_NAME,
  PHONE_EXT,
  LOCATION,
  PHONE_NO
)
AS
 SELECT
  emp_no, first_name, last_name, phone_ext, location, phone_no
  FROM employee, department
  WHERE employee.dept_no = department.dept_no;

COMMIT WORK;

/* Grant Roles for this database */
CREATE ROLE TEST_ROLE;

COMMIT WORK;

/* Grant permissions for this database */
GRANT DELETE, INSERT, SELECT, UPDATE, REFERENCES ON COUNTRY TO PUBLIC WITH GRANT OPTION;
GRANT DELETE, INSERT, SELECT, UPDATE, REFERENCES ON CUSTOMER TO PUBLIC WITH GRANT OPTION;
GRANT DELETE, INSERT, SELECT, UPDATE, REFERENCES ON DEPARTMENT TO PUBLIC WITH GRANT OPTION;
GRANT DELETE, INSERT, SELECT, UPDATE, REFERENCES ON EMPLOYEE TO PUBLIC WITH GRANT OPTION;
GRANT DELETE, INSERT, SELECT, UPDATE, REFERENCES ON EMPLOYEE_PROJECT TO PUBLIC WITH GRANT OPTION;
GRANT DELETE, INSERT, SELECT, UPDATE, REFERENCES ON JOB TO PUBLIC WITH GRANT OPTION;
GRANT DELETE, INSERT, SELECT, UPDATE, REFERENCES ON PHONE_LIST TO PUBLIC WITH GRANT OPTION;
GRANT DELETE, INSERT, SELECT, UPDATE, REFERENCES ON PROJECT TO PUBLIC WITH GRANT OPTION;
GRANT DELETE, INSERT, SELECT, UPDATE, REFERENCES ON PROJ_DEPT_BUDGET TO PUBLIC WITH GRANT OPTION;
GRANT DELETE, INSERT, SELECT, UPDATE, REFERENCES ON SALARY_HISTORY TO PUBLIC WITH GRANT OPTION;
GRANT DELETE, INSERT, SELECT, UPDATE, REFERENCES ON SALES TO PUBLIC WITH GRANT OPTION;
GRANT EXECUTE ON PROCEDURE ADD_EMP_PROJ TO PUBLIC WITH GRANT OPTION;
GRANT EXECUTE ON PROCEDURE ALL_LANGS TO PUBLIC WITH GRANT OPTION;
GRANT EXECUTE ON PROCEDURE DELETE_EMPLOYEE TO PUBLIC WITH GRANT OPTION;
GRANT EXECUTE ON PROCEDURE DEPT_BUDGET TO PUBLIC WITH GRANT OPTION;
GRANT EXECUTE ON PROCEDURE GET_EMP_PROJ TO PUBLIC WITH GRANT OPTION;
GRANT EXECUTE ON PROCEDURE MAIL_LABEL TO PUBLIC WITH GRANT OPTION;
GRANT EXECUTE ON PROCEDURE ORG_CHART TO PUBLIC WITH GRANT OPTION;
GRANT EXECUTE ON PROCEDURE SHIP_ORDER TO PUBLIC WITH GRANT OPTION;
GRANT EXECUTE ON PROCEDURE SHOW_LANGS TO PUBLIC WITH GRANT OPTION;
GRANT EXECUTE ON PROCEDURE SUB_TOT_BUDGET TO PUBLIC WITH GRANT OPTION;

/* Meta data descriptions.  This syntax requires InterBase 2020 or higher.  Some tables require ODS18 and higher */

COMMIT WORK;
